function logL = AppLoglikelihood_FMLE_Frank(Coefs, X,Y,d)
% Calculates FMLE assuming Frank copula



lX = exp(Coefs(1));
tX = exp(Coefs(2));
lY = exp(Coefs(3));
tY = exp(Coefs(4));
r = Coefs(5);

%Pareto log likelihood

logLX=log(tX)+tX*log(lX)-log(lX+X)*(tX+1);
logLY=log(tY)+tY*log(lY)-log(lY+Y)*(tY+1);


% Frank copula log density
F1 = 1 - ((lX+X)/lX).^(-tX); % Pareto CDF
F2 = 1 - ((lY+Y)/lY).^(-tY);

a= -r*exp(-r.*(F1+F2))*(exp(-r)-1);
b=exp(-r)+exp(-r.*(F1+F2))-exp(-r.*F1)-exp(-r.*F2);
logc = log(a./(b.*b));


% Derivative of copula wrt u2

C2= exp(r).*(-1+exp(r.*F1))./(-exp(r.*(F1+F2))+ exp(r).*(-1+exp(r.*F1)+exp(r.*F2)));

% joint log likelihood

logL =(1-d).*(logLX+logLY+logc)+d.*(logLY+log(1-C2));


logL = -sum(logL);

end