function logL = AppLoglikelihood_FMLE_Gum(Coefs, X,Y,d)
% Calculates FMLE assuming Frank copula


lX = exp(Coefs(1));
tX = exp(Coefs(2));
lY = exp(Coefs(3));
tY = exp(Coefs(4));
a = exp(Coefs(5))+1;

%Pareto log likelihood

logLX=log(tX)+tX*log(lX)-log(lX+X)*(tX+1);
logLY=log(tY)+tY*log(lY)-log(lY+Y)*(tY+1);

% Frank copula log density
F1 = 1 - ((lX+X)/lX).^(-tX); % Pareto CDF
F2 = 1 - ((lY+Y)/lY).^(-tY);

logc = (-1).*(((-1).*log(F1)).^a+((-1).*log(F2)).^a).^(a.^(-1))+log(F1.^(-1).*F2.^(-1).*((-1).*log(F1)).^((-1)+a).*((-1)+a+(((-1).*log(F1)).^a+((-1).*log(F2)).^a).^( ...
    a.^(-1))).*(((-1).*log(F1)).^a+((-1).*log(F2)).^a).^((-2)+a.^(-1)).*((-1).*log(F2)).^((-1)+a));


% Derivative of copula wrt u2

C2 = exp(1).^((-1).*(((-1).*log(F1)).^a+((-1).*log(F2)).^a).^(a.^(-1))).*F2.^(-1).*(((-1).*log(F1)).^a+((-1).*log(F2)).^a).^((-1)+a.^(-1)).*((-1).*log(F2)).^((-1)+a);

% joint log likelihood

logL =(1-d).*(logLX+logLY+logc)+d.*(logLY+log(1-C2));
logL = -sum(logL);

end