function logL = AppLoglikelihood_QMLE(Coefs, X,Y,d)
% Calculates QMLE assuming independence


    n=length(X);
    
    lX = exp(Coefs(1));
    tX = exp(Coefs(2));
    lY = exp(Coefs(3));
    tY = exp(Coefs(4));    

    

    
 %Pareto log likelihood
    
    logLY=n*log(tY)+n*tY*log(lY)-sum(log(lY+Y))*(tY+1);

 
 
 % Censored Pareto log likelihood
    logLX=0;
    for i=1:n
        ll = (1-d(i))*(log(tX)+tX*log(lX)-log(lX+X(i))*(tX+1))+d(i)*tX*(log(lX)-log(lX+X(i)));
        logLX = logLX + ll;
    end
    
    logL=-(logLX+logLY);

     
     
end 




