function nlogL = AppLoglikelihood_SMLE_Bernstein(Coeff, X, Y, d, k, nchoose)

n=length(X);

lX = exp(Coeff(1));
tX = exp(Coeff(2));
lY = exp(Coeff(3));
tY = exp(Coeff(4));

U = 1 - (1+X/lX).^(-tX);   % Pareto CDF
V = 1 - (1+Y/lY).^(-tY);

temp=exp(Coeff(5:end));
temp=temp/sum(temp);
I=reshape(temp,k,k);

C2 = zeros(n,1);
logL = zeros(n,1);
lf1 = zeros(n,1);
lf2 = zeros(n,1);
lc = zeros(n,1);

prod1U=ones(k,1);
prod1V=ones(k,1);


for l = 1:n

    u=U(l);
    v=V(l);
    x=X(l);
    y=Y(l);

    for i=2:k
        prod1U(i)=prod1U(i-1)*(1-u);
        prod1V(i)=prod1V(i-1)*(1-v);
    end

    prodU = 1;
    sieve_sum = 0;

    for i = 1:k
        prodV=1;


        %IntU=betainc(u,i,k-i+1)*beta(i,k-i+1);
        %note that beta function = 1/(nchoose(i)*k)

        if d(l)==1, IntUpart=betainc(u,i,k-i+1); end
        tempu=k*nchoose(i)*prodU*prod1U(k-i+1);

        for j = 1:k
            tempv=k*I(i,j)*nchoose(j)*prodV*prod1V(k-j+1);
            if d(l)==1, C2(l) = C2(l) + IntUpart*tempv; end
            sieve_sum=sieve_sum+tempv*tempu;
            prodV=prodV*v;
        end
        prodU=prodU*u;

    end

    c_den=sieve_sum;

    lf1(l) = log(tX) - (tX+1)* log(lX+x) + tX * log(lX);
    lf2(l) = log(tY) - (tY+1)* log(lY+y) + tY * log(lY);
    lc(l) = log(c_den);

    if d(l)==0
        logL(l)=lf1(l)+lf2(l)+lc(l);
    else
        if C2(l)>=1 %this may happen due to numerical issues
            C2(l)=U(l); %best estimate under independence
        end

        logL(l)=lf2(l)+log(1-C2(l));
    end

end

rest=1/k;
penalty=sum((sum(I,1)-rest).^2+(sum(I,2)'-rest).^2);

const=1e6; %large constant to make sure penalty bites

nlogL=-sum(logL);
nlogL=nlogL+const*penalty;%add penalty


end

