function logl = QMLELogLikRetVolVolume(parameters,sample)
    
    % parameters(1) - parameters(3) - returns mu, sigma, nu (t-locscale)
    % parameters(4) - parameters(6) - volume change mu, sigma, nu
    % (t-locscale)
    % parameters(7) - parameters(8) - volatility distribution a, b (Beta)
    
    first_t_dist = makedist('tLocationScale','mu',parameters(1),'sigma',parameters(2),'nu',parameters(3));
    second_t_dist = makedist('tLocationScale','mu',parameters(4),'sigma',parameters(5),'nu',parameters(6));
    vol_dist = makedist('Beta','a',parameters(7),'b',parameters(8));
    
    % log-likilihood contribution from marginal models
    
    marginal_models_log_lik = sum(log(pdf(first_t_dist,sample(:,1))))+...
        sum(log(pdf(second_t_dist,sample(:,2)))) + ...
        sum(log(pdf(vol_dist,sample(:,3))));
    
    logl = -marginal_models_log_lik;

end