function [betaX, betaY, logLSMLE, BIC, AIC] = Estimate(X, Y, k)



    muX=mean(X);
    muY=mean(Y);
    
    U=expcdf(X,muX);
    V=expcdf(Y,muY);

    n=length(U);   
        
    In=zeros(k,k); %emprical histogram
         
    count=1/n;
    for l = 1:n      
            
      i=floor(U(l)*k)+1;   
      j=floor(V(l)*k)+1; 

      In(i,j) = In(i,j) + count; 
    end

    %contant to form polynomials faster
    nchoose=zeros(k,1);
        
        for j = 1:k
            nchoose(j)=nchoosek(k-1,j-1);
        end


        nchoose=zeros(k,1);
        
        for j = 1:k
            nchoose(j)=nchoosek(k-1,j-1);
        end

     In(In==0)=eps;



    Init=log([muX;muY;reshape(In,k*k,1)]);    
    Options = optimset('MaxIter', 1e6, 'MaxFunEvals', 1e6,  'Display', 'off'); 

   [OptI,nlogLSMLE]=fminunc(@(params) Loglikelihood_SMLE_Bernstein_trans(params,X, Y, k, nchoose), Init,Options);

    BC=exp(OptI(3:end));
    BC=BC/sum(BC);
    BC=reshape(BC,k,k);

    betaX = exp(OptI(1));
    betaY = exp(OptI(2));

    rest=1/k;
    penalty=sum((sum(BC,1)-rest).^2+(sum(BC,2)'-rest).^2)/(2*k);

    const=1e4; %large constant 
    logLSMLE=-nlogLSMLE+const*penalty;
        
npar=length(OptI)-2*k+1; %number of free params

BIC=-2*logLSMLE+npar*log(n);
AIC=-2*logLSMLE+2*npar;

end

