function [betaX, betaY] = Estimate_FMLE_PMLE_QMLE_IQMLE(X, Y)

Options = optimset('TolX', 1e-5, 'TolFun', 1e-5, ...
    'MaxIter', 50000, ...
    'MaxFunEvals', 2 * 50000,...
    'Display', 'off');
betaX=zeros(2,1);
betaY=zeros(2,1);

muX=mean(X);
muY=mean(Y);

%Full MLE

d=0.05;% true value

Init=log([muX;muY;d]);

OptFMLE = fminunc(@Loglikelihood_FMLE, Init, Options, X, Y);
betaX(1) = exp(OptFMLE(1));
betaY(1) = exp(OptFMLE(2));

%Pseudo MLE misspecified copula - Gaussian
d=(.8+1)/2/(1-(.8+1)/2); %pseudo-true value for Gaussian copula parameter

Init=log([muX;muY;d]);

OptPMLE = fminunc(@Loglikelihood_PMLEmisGaus, Init, Options, X, Y);
betaX(2) = exp(OptPMLE(1));
betaY(2) = exp(OptPMLE(2));

%Pseudo MLE misspecified copula - Clayton rotated

d=3; % %pseudo-true value for rotated Clayton copula parameter

Init=log([muX;muY;d]);

OptPMLE = fminunc(@Loglikelihood_PMLEmisClayr, Init, Options, X, Y);
betaX(3) = exp(OptPMLE(1));
betaY(3) = exp(OptPMLE(2));

%QMLE

Init=log([muX;muY]);
OptQMLE = fminunc(@Loglikelihood_QMLE, Init, Options, X, Y);
betaX(4) = exp(OptQMLE(1));
betaY(4) = exp(OptQMLE(2));

%IQMLE

Init=log([muX;muY]);
OptIQMLE = fminunc(@IQMLE, Init, Options, X, Y);
betaX(5) = exp(OptIQMLE(1));
betaY(5) = exp(OptIQMLE(2));

end

