function [betaX, betaY] = Estimate_QMLE_FMLE(X, Y)


	
    Options = optimset('TolX', 1e-5, 'TolFun', 1e-5, ...
                    'MaxIter', 50000, ...   
                    'MaxFunEvals', 2 * 50000,...
                    'Display', 'off');
    betaX=zeros(2,1); 
    betaY=zeros(2,1); 

    %QMLE
    
    muX=log(mean(X));
    muY=log(mean(Y));

    
 	[OptQMLE, logLQMLE] = fminunc(@Loglikelihood_QMLE, [muX;muY], Options, X, Y);
	betaX(1) = exp(OptQMLE(1));
    betaY(1) = exp(OptQMLE(2));

    %Full MLE
    
    muX=log(mean(X));
    muY=log(mean(Y));
    
    d=log(0.05);
    
 	[OptFMLE, logLFMLE] = fminunc(@Loglikelihood_FMLE, [muX;muY;d], Options, X, Y);
	betaX(2) = exp(OptFMLE(1));
    betaY(2) = exp(OptFMLE(2));

    
    
	
end

