function [betaX, betaY, c_coef, logLSMLE, BIC, AIC] = Estimate_SMLE_Tensor_series(X, Y, k, formBasis, Integ_Basis)

n=length(X);


muX=mean(X);
muY=mean(Y);

Ini_c_coef=zeros(size(Integ_Basis,2),1); %assume independece copula as initial values


Init=[log([muX/(max(X)-muX);muY/(max(Y)-muY)]);Ini_c_coef];
Options = optimset('MaxIter', 1e6, 'MaxFunEvals', 1e6,  'Display', 'off');

[OptI,nlogLSMLE]=fminunc(@(params) Loglikelihood_SMLE_Tensor_series(params,X, Y, k, formBasis, Integ_Basis), Init,Options);

c_coef=OptI(3:end);

betaX=1/(1+exp(-OptI(1)))*max(X);
betaY=1/(1+exp(-OptI(2)))*max(Y);

logLSMLE=-nlogLSMLE;

npar=length(OptI); %number of params

BIC=-2*logLSMLE+npar*log(n);
AIC=-2*logLSMLE+2*npar;

end

