function [betaX, betaY, logLSMLE, BIC, AIC] = Estimate_cons(X, Y, k)



    muX=mean(X);
    muY=mean(Y);
    
    U=expcdf(X,muX);
    V=expcdf(Y,muY);

    n=length(U);   
        
    In=zeros(k,k); %emprical histogram
         
    count=1/n;
    for l = 1:n      
            
      i=floor(U(l)*k)+1;   
      j=floor(V(l)*k)+1; 

      In(i,j) = In(i,j) + count; 
    end

    %constant to form polynomials faster
    nchoose=zeros(k,1);
        
        for j = 1:k
            nchoose(j)=nchoosek(k-1,j-1);
        end


        nchoose=zeros(k,1);
        
        for j = 1:k
            nchoose(j)=nchoosek(k-1,j-1);
        end

     In(In==0)=eps;

% Optimization constraints

lb = [eps;eps;ones(k*k,1)*eps];
ub = [Inf;Inf;ones(k*k,1)/k-eps];

% constraints on Sieve parameters

Aeq = zeros(2*k-1,2+k*k); 

for i=1:k

    Aeq(i,2+k*(i-1)+1:2+k*(i-1)+k) = ones(1,k); %sum of rows 
    if i<k
        Aeq(k+i,2+i:k:end) = ones(1,k); %sum of columns, every kth 
    end
end
beq = ones(2*k-1,1)/k;



    Init=[muX;muY;reshape(In,k*k,1)];    
    options = optimoptions('fmincon','Display','off','Algorithm','sqp','ScaleProblem','obj-and-constr');

   [OptI,nlogLSMLE]=fmincon(@(params) Loglikelihood_SMLE_Bernstein_cons(params,X, Y, k, nchoose), Init,[],[],Aeq,beq,lb,ub,[],options);

    betaX = OptI(1);
    betaY = OptI(2);

logLSMLE=-nlogLSMLE;
        
npar=length(OptI);

BIC=-2*logLSMLE+npar*log(n);
AIC=-2*logLSMLE+2*npar;

end

