%matlabpool(8);

%alpha=0.05; %dependence parameter
muX=.5;      %marginal parameter
muY=.5;
seed=1;
N=1000000;      %sample size


a= [%-12.2615
-7.9019
-5.8212
-4.4659
-3.446
-2.61
-1.8835
-1.2238
-0.6029
0.6029
1.2238
1.8835
2.61
3.446
4.4659
5.8212
7.9019
%12.2615
];



for ia=1:length(a)
    
    rng(3);
    alpha=a(ia);
    
    UV=copularnd('Frank',alpha,N);
    U=UV(:,1);
    V=UV(:,2);
    
    X = expinv(U,muX);
    Y = expinv(V,muY);
    
    
    dlXdmuX=zeros(N,1);
    dlYdmuY=zeros(N,1);
    dcdmuX=zeros(N,1);
    dcdmuY=zeros(N,1);
    
    c=zeros(N,1);
    dcdalpha=zeros(N,1);
    
    dlXdmuX2=zeros(N,1);
    dlYdmuY2=zeros(N,1);
    
    
    for i=1:N
        
        u=U(i);
        v=V(i);
        x=X(i);
        y=Y(i);
        
        dlXdmuX(i)=(x-muX)/(muX^2);
        dlYdmuY(i)=(y-muY)/(muY^2);
        
        dFdmuX=-x*exp(-x/muX)/(muX^2);
        dFdmuY=-y*exp(-y/muY)/(muY^2);
        
        dcdu=[(-1).*alpha.^2.*exp(1).^(alpha.*(1+u+v)).*((-1)+exp(1).^alpha).*( ...
  (-1).*exp(1).^(alpha.*(u+v))+exp(1).^alpha.*(1+exp(1).^(alpha.*u)+ ...
  (-1).*exp(1).^(alpha.*v))).*((-1).*exp(1).^(alpha.*(u+v))+exp(1) ...
  .^alpha.*((-1)+exp(1).^(alpha.*u)+exp(1).^(alpha.*v))).^(-3)];

        
        dcdv=[alpha.^2.*exp(1).^(alpha.*(1+u+v)).*((-1)+exp(1).^alpha).*(exp(1) ...
  .^(alpha.*(u+v))+exp(1).^alpha.*((-1)+exp(1).^(alpha.*u)+(-1).* ...
  exp(1).^(alpha.*v))).*((-1).*exp(1).^(alpha.*(u+v))+exp(1) ...
  .^alpha.*((-1)+exp(1).^(alpha.*u)+exp(1).^(alpha.*v))).^(-3)];
        
        
        dcdmuX(i)=dcdu*dFdmuX;
        dcdmuY(i)=dcdv*dFdmuY;
        
        c(i)=copulapdf('Frank',[u,v],alpha);
        
        dcdalpha(i)=[exp(1).^(alpha.*(1+u+v)).*((-1).*exp(1).^(alpha.*(u+v))+exp(1) ...
  .^alpha.*((-1)+exp(1).^(alpha.*u)+exp(1).^(alpha.*v))).^(-3).*( ...
  exp(1).^(alpha.*(2+v)).*(1+alpha.*(u+(-1).*v))+exp(1).^(alpha+ ...
  alpha.*u).*((-1)+alpha.*(1+u+(-1).*v))+exp(1).^(alpha.*(2+u)).*(1+ ...
  alpha.*((-1).*u+v))+exp(1).^(alpha+alpha.*v).*((-1)+alpha.*(1+(-1) ...
  .*u+v))+exp(1).^(alpha.*(1+u+v)).*((-1)+alpha.*((-2)+u+v))+exp(1) ...
  .^(alpha.*(u+v)).*(1+(-1).*alpha.*((-1)+u+v))+exp(1).^alpha.*(1+ ...
  alpha.*((-1)+u+v))+(-1).*exp(1).^(2.*alpha).*(1+alpha.*(u+v)))];
        
        dlXdmuX2(i)=(muX-2*x)/(muX^3);
        dlYdmuY2(i)=(muY-2*y)/(muY^3);
        
        
    end
    
    %qmle var
    
    
    Iqmle=[dlXdmuX dlYdmuY]'*[dlXdmuX dlYdmuY]/N;
    H=[mean(dlXdmuX2) 0; 0 mean(dlYdmuY2)];
    
    invH=inv(H);
    qmlevar_rob=invH*Iqmle*invH;
    
    %fmle var
    
    score_muX=dlXdmuX+dcdmuX./c;
    score_muY=dlYdmuY+dcdmuY./c;
    score_alpha=dcdalpha./c;
    
    Ifmle=[score_muX score_muY score_alpha]'*[score_muX score_muY score_alpha]/N;
    fmlevar=inv(Ifmle);
    
    
    k=10;
    
    Basis  = formCosBasis_var2(U,V,k);
    
    Pu=score_muX;
    Z=Basis./repmat(c,1,k*k);
    
    OptI1=-(Z'*Z)\(Z'*Pu);
    g1 = Basis * OptI1;
    
    Pv=score_muY;
    OptI2=-(Z'*Z)\(Z'*Pv);
    
    g2 = Basis * OptI2;
    
    score_u=score_muX+g1./c;
    score_v=score_muY+g2./c;
    
    Ismle=[score_u score_v]'*[score_u score_v]/N;
    smlevar=inv(Ismle);
    
    
    fprintf('%.3f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f\n',alpha,fmlevar(1,1),qmlevar_rob(1,1),smlevar(1,1),fmlevar(1,1)/qmlevar_rob(1,1),smlevar(1,1)/qmlevar_rob(1,1),fmlevar(2,2),qmlevar_rob(2,2),smlevar(2,2),fmlevar(2,2)/qmlevar_rob(2,2),smlevar(2,2)/qmlevar_rob(2,2));
    
end