%matlabpool(8);

%alpha=0.05; %dependence parameter
muX=0.1;      %marginal parameter
muY=0.5;
N=1000000;      %sample size



a= [
-0.8135
-0.7167
-0.618
-0.5176
-0.4158
-0.3129
-0.2091
-0.1047
0.1047
0.2091
0.3129
0.4158
0.5176
0.618
0.7167
0.8135];


for ia=1:length(a)
    
    rng(2);
    alpha=a(ia);
    
    UV=copularnd('Gaussian',alpha,N);
    U=UV(:,1);
    V=UV(:,2);
    
    X = expinv(U,muX);
    Y = expinv(V,muY);
    
    
    dlXdmuX=zeros(N,1);
    dlYdmuY=zeros(N,1);
    dcdmuX=zeros(N,1);
    dcdmuY=zeros(N,1);
    
    c=zeros(N,1);
    dcdalpha=zeros(N,1);
    
    dlXdmuX2=zeros(N,1);
    dlYdmuY2=zeros(N,1);
    
    
    for i=1:N
        
        u=U(i);
        v=V(i);
        x=X(i);
        y=Y(i);
        
        dlXdmuX(i)=(x-muX)/(muX^2);
        dlYdmuY(i)=(y-muY)/(muY^2);
        
        dFdmuX=-x*exp(-x/muX)/(muX^2);
        dFdmuY=-y*exp(-y/muY)/(muY^2);
        
        erciu=erfcinv(2.*u);        
        erciv=erfcinv(2.*v);        
        
        dcdu=2.*alpha.*(1+(-1).*alpha.^2).^(-3/2).*exp(((-1)+alpha.^2).^( ...
  -1).*(((-1)+2.*alpha.^2).*erciu.^2+(-2).*alpha.*erciu.*erciv+alpha.^2.*erciv ...
  .^2)).*pi.^(1/2).*(alpha.*erciu+(-1).*erciv);

        
        dcdv=2.*alpha.*(1+(-1).*alpha.^2).^(-3/2).*exp(((-1)+alpha.^2) ...
  .^(-1).*(alpha.^2.*erciu.^2+(-2).*alpha.*erciu.*erciv+((-1)+2.*alpha.^2).*erciv.^2) ...
  ).*pi.^(1/2).*((-1).*erciu+alpha.*erciv);        
        
        dcdmuX(i)=dcdu*dFdmuX;
        dcdmuY(i)=dcdv*dFdmuY;
        
        c(i)=copulapdf('Gaussian',[u,v],alpha);
        
        dcdalpha(i)=(-1).*(1+(-1).*alpha.^2).^(-5/2).*exp(alpha.*((-1)+alpha.^2) ...
  .^(-1).*(alpha.*erciu.^2+(-2).*erciu.*erciv+alpha.*erciv.^2)).*(2.*alpha.* ...
  erciu.^2+(-2).*(1+alpha.^2).*erciu.*erciv+alpha.*((-1)+alpha.^2+2.*erciv.^2));
        
        dlXdmuX2(i)=(muX-2*x)/(muX^3);
        dlYdmuY2(i)=(muY-2*y)/(muY^3);
        
        
    end
    
    %qmle var
    
    
    Iqmle=[dlXdmuX dlYdmuY]'*[dlXdmuX dlYdmuY]/N;
    H=[mean(dlXdmuX2) 0; 0 mean(dlYdmuY2)];
    
    invH=inv(H);
    qmlevar_rob=invH*Iqmle*invH;
    
    %fmle var
    
    score_muX=dlXdmuX+dcdmuX./c;
    score_muY=dlYdmuY+dcdmuY./c;
    score_alpha=dcdalpha./c;
    
    Ifmle=[score_muX score_muY score_alpha]'*[score_muX score_muY score_alpha]/N;
    fmlevar=inv(Ifmle);
    
    
    k=10;
    
    Basis  = formCosBasis_var2(U,V,k);
    Z=Basis./c;
    
    g=-Z*((Z'*Z)\(Z'*[score_muX score_muY]));
    
    
    
    score_uv=[score_muX score_muY]+g;
    
    
    Ismle=score_uv'*score_uv/N;
    smlevar=inv(Ismle);
    
    
    fprintf('%.3f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f\n',alpha,fmlevar(1,1),qmlevar_rob(1,1),smlevar(1,1),fmlevar(1,1)/qmlevar_rob(1,1),smlevar(1,1)/qmlevar_rob(1,1),fmlevar(2,2),qmlevar_rob(2,2),smlevar(2,2),fmlevar(2,2)/qmlevar_rob(2,2),smlevar(2,2)/qmlevar_rob(2,2));
    
end