%Estimates semiparametric bound for 3d case with Gaussian marginals and
%Placket copula

%code is very slow - computer cluster was used for speed

mu=[0.1 0.5 1];     %marginal parameters
N=1e6;              %sample size - large sample was used for precision, if reduced at least 1e5 should be used for the given J_N


%dependence parameter
a= [
-0.8135
-0.7167
-0.618
-0.5176
-0.4158
-0.3129
-0.2091
-0.1047
0.1047
0.2091
0.3129
0.4158
0.5176
0.618
0.7167
0.8135];



for ia=1:length(a)
    
    a1=a(ia);
    a2=0.5; %we also used a2=0.7

    sig=[1 a1 a1; 
         a1 1 a2; 
         a1 a2 1];
    
    U=copularnd('Gaussian',sig,N);
  
    
    X1 = expinv(U(:,1),mu(1));
    X2 = expinv(U(:,2),mu(2));
    X3 = expinv(U(:,3),mu(3));
    
    dldmu=zeros(N,3);
    dldmu2=zeros(N,3);
    dFdmu=zeros(N,3);

    
    dcdmu=zeros(N,3);
       
    c=zeros(N,1);
    
    dcda=zeros(N,2);   
    
    for i=1:N
        
        u=U(i,:);
        x=[X1(i) X2(i) X3(i)];
        
        dldmu(i,:)=(x-mu)./(mu.^2);
        dFdmu=-x.*exp(-x./mu)./(mu.^2);
        
        erciu1=erfcinv(2.*u(1));        
        erciu2=erfcinv(2.*u(2));        
        erciu3=erfcinv(2.*u(3));        
        
        dcdu1=-2.*a1.*((-1)+a2).*(((-1)+2.*a1.^2+(-1).*a2).*((-1)+a2)).^(-3/2).*exp(((-1)+a2).^(-1).*(1+(-2).*a1.^2+a2).^(-1).* ...
  (((-1)+a2).*(1+(-4).*a1.^2+a2).*erciu1.^2+(a1.^2+(-2).*a1.^2.*a2+a2.^2).*erciu2.^2+2.*(a1.^2+( ...
  -1).*a2).*erciu2.*erciu3+(a1.^2+(-2).*a1.^2.*a2+a2.^2).*erciu3.^2+2.*a1.*((-1)+a2).* ...
  erciu1.*(erciu2+erciu3))).*pi.^(1/2).*(2.*a1.*erciu1+(-1).*erciu2+(-1).*erciu3);
        
        dcdu2=-2.*(((-1)+2.*a1.^2+(-1).*a2).*((-1)+a2)).^(-3/2).*exp(((-1)+2.*a1.^2+(-1).*a2).^(-1).*((-1)+a2).^(-1).*(2.* ...
  a1.^2.*((-1)+a2).*erciu1.^2+(1+(-2).*a2.^2+a1.^2.*((-3)+4.*a2)).*erciu2.^2+2.*((-1).*a1.^2+a2).* ...
  erciu2.*erciu3+(-1).*(a1.^2.*(1+(-2).*a2)+a2.^2).*erciu3.^2+(-2).*a1.*((-1)+a2).* ...
  erciu1.*(erciu2+erciu3))).*pi.^(1/2).*((a1+(-1).*a1.*a2).*erciu1+(-1).*(a1.^2.*(1+(-2).*a2)+a2.^2).*erciu2+((-1).*a1.^2+a2).*erciu3);                

        dcdu3=(-2).*(((-1)+2.*a1.^2+(-1).*a2).*((-1)+a2)).^(-3/2).*exp(((-1)+2.*a1.^2+(-1).*a2).^(-1).*((-1)+a2).^(-1).*(2.* ...
  a1.^2.*((-1)+a2).*erciu1.^2+(-1).*(a1.^2.*(1+(-2).*a2)+a2.^2).*erciu2.^2+2.*((-1).*a1.^2+a2).* ...
  erciu2.*erciu3+(1+(-2).*a2.^2+a1.^2.*((-3)+4.*a2)).*erciu3.^2+(-2).*a1.*((-1)+a2).* ...
  erciu1.*(erciu2+erciu3))).*pi.^(1/2).*((a1+(-1).*a1.*a2).*erciu1+((-1).*a1.^2+a2).*erciu2+(-1).*(a1.^2.*(1+(-2).*a2)+a2.^2).*erciu3);  

        dcdmu(i,:)=[dcdu1 dcdu2 dcdu3].*dFdmu;

        
        c(i)=copulapdf('Gaussian',u,sig);
        
        dcda(i,1)=(-2).*(((-1)+2.*a1.^2+(-1).*a2).*((-1)+a2)).^(-1/2).*(1+(-2).*a1.^2+a2).^(-2).*exp((-1).*((-1)+2.*a1.^2+(-1).*a2) ...
  .^(-1).*((-1)+a2).^(-1).*((-2).*a1.^2.*((-1)+a2).*erciu1.^2+(a1.^2+(-2).*a1.^2.*a2+a2.^2).*erciu2.^2+2.*(a1.^2+(-1).*a2).*erciu2.*erciu3+(a1.^2+(-2).*a1.^2.*a2+a2.^2).*erciu3.^2+ ...
  2.*a1.*((-1)+a2).*erciu1.*(erciu2+erciu3))).*(2.*a1.*(1+a2).*erciu1.^2+(-1).*(1+2.*a1.^2+a2).*erciu1.*(erciu2+erciu3)+a1.*((-1)+2.*a1.^2+(-1).*a2+ ...
  erciu2.^2+2.*erciu2.*erciu3+erciu3.^2));

        dcda(i,2)=(-1).*((1+(-1).*a2).*(1+(-2).*a1.^2+a2)).^(-5/2).*exp((-1).*((-1)+2.*a1.^2+(-1).*a2).^(-1).*((-1)+a2).^(-1).*((-2) ...
  .*a1.^2.*((-1)+a2).*erciu1.^2+(a1.^2+(-2).*a1.^2.*a2+a2.^2).*erciu2.^2+2.*(a1.^2+(-1).*a2).* ...
  erciu2.*erciu3+(a1.^2+(-2).*a1.^2.*a2+a2.^2).*erciu3.^2+2.*a1.*((-1)+a2).* ...
  erciu1.*(erciu2+erciu3))).*((-2).*a1.^2.*((-1)+a2).^2.*erciu1.^2+2.*(( ...
  -1)+a1.^2).*(a1.^2+(-1).*a2).*erciu2.^2+(-2).*(1+2.*a1.^4+a2.^2+(-2).*a1.^2.*(1+a2)).*erciu2.* ...
  erciu3+2.*a1.*((-1)+a2).^2.*erciu1.*(erciu2+erciu3)+(a1.^2+(-1).*a2).*(( ...
  (-1)+2.*a1.^2+(-1).*a2).*((-1)+a2)+2.*((-1)+a1.^2).*erciu3.^2));
        
        dldmu2(i,:)=(mu-2.*x)./(mu.^3);
        
        
        
    end
    
    %qmle var
    
    
    Iqmle=dldmu'*dldmu/N;
    H=[mean(dldmu2(:,1)) 0 0; 0 mean(dldmu2(:,2)) 0; 0 0 mean(dldmu2(:,3))];
    
    invH=inv(H);
    qmlevar_rob=invH*Iqmle*invH;
    
    %fmle var
    
    score_mu=dldmu+dcdmu./c;
    score_a=dcda./c;
        
    Ifmle=score_mu'*score_mu/N;
    fmlevar=inv(Ifmle);
    
    
    k=10;
    
    Basis  = formCosBasis_var3d(U(:,1),U(:,2),U(:,3),k);        
    Z=Basis./c;   
    
    gdivc = -Z*((Z'*Z)\(Z'*score_mu));        
    
    score_u=score_mu+gdivc;
       
    Ismle=score_u'*score_u/N;
    smlevar=inv(Ismle);
    
    
    fprintf('%.3f %.3f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f\n',a1,a2,fmlevar(1,1),qmlevar_rob(1,1),smlevar(1,1),fmlevar(1,1)/qmlevar_rob(1,1),smlevar(1,1)/qmlevar_rob(1,1),fmlevar(2,2),qmlevar_rob(2,2),smlevar(2,2),fmlevar(2,2)/qmlevar_rob(2,2),smlevar(2,2)/qmlevar_rob(2,2),fmlevar(3,3),qmlevar_rob(3,3),smlevar(3,3),fmlevar(3,3)/qmlevar_rob(3,3),smlevar(3,3)/qmlevar_rob(3,3));
    
end