%Estimates semiparametric bound for 2d case with exponential  marginals and
%Plackett copula


muX=.5;      %marginal parameter
muY=1;
N=1e6;      %sample size
seed=1;

%dependence parameter
a= [
    0.0412222
    0.0784556
    0.128851
    0.195478
    0.282631
    0.396273
    0.544781
    0.740148
    1.35108
    1.8356
    2.52351
    3.53818
    5.11566
    7.76089
    12.7461
    24.2588
    ];



for ia=1:length(a)


    alpha=a(ia);

    [U, V]=plackett_rnd(alpha,N,seed);

    X = expinv(U,muX);
    Y = expinv(V,muY);


    dlXdmuX=zeros(N,1);
    dlYdmuY=zeros(N,1);
    dcdmuX=zeros(N,1);
    dcdmuY=zeros(N,1);

    c=zeros(N,1);
    dcdalpha=zeros(N,1);

    dlXdmuX2=zeros(N,1);
    dlYdmuY2=zeros(N,1);


    for i=1:N

        u=U(i);
        v=V(i);
        x=X(i);
        y=Y(i);

        dlXdmuX(i)=(x-muX)/(muX^2);
        dlYdmuY(i)=(y-muY)/(muY^2);

        dFdmuX=-x*exp(-x/muX)/(muX^2);
        dFdmuY=-y*exp(-y/muY)/(muY^2);

        dcdu=((-1+alpha)*alpha*(3*(-1+u-alpha*u+v+alpha*v)*(1+(-1+alpha)*(u+v-2*u*v))+(1-2*v)*(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)))...
            /(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)^(5/2);

        dcdv=((-1+alpha)*alpha*(3*(-1+u+alpha*u+v-alpha*v)*(1+(-1+alpha)*(u+v-2*u*v))+(1-2*u)*(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)))...
            /(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)^(5/2);


        dcdmuX(i)=dcdu*dFdmuX;
        dcdmuY(i)=dcdv*dFdmuY;

        c(i)=plackett_pdf(u,v,alpha);

        dcdalpha(i)=(-3*alpha*(2*(-1+alpha)*(u^2)+2*v*(1+(-1+alpha)*v)+u*(2-4*alpha*v))*(1+(-1+alpha)*(u+v-2*u*v))+2*alpha*(u+v-2*u*v)*(-4*(-1+alpha)*...
            alpha*u*v+(1+(-1+alpha)*(u+v))^2)+2*(1+(-1+alpha)*(u+v-2*u*v))*(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2))/(2*(-4*(-1+alpha)*...
            alpha*u*v+(1+(-1+alpha)*(u+v))^2)^(5/2));

        dlXdmuX2(i)=(muX-2*x)/(muX^3);
        dlYdmuY2(i)=(muY-2*y)/(muY^3);


    end

    %qmle var


    Iqmle=[dlXdmuX dlYdmuY]'*[dlXdmuX dlYdmuY]/N;
    H=[mean(dlXdmuX2) 0; 0 mean(dlYdmuY2)];

    invH=inv(H);
    qmlevar_rob=invH*Iqmle*invH;

    %fmle var

    score_muX=dlXdmuX+dcdmuX./c;
    score_muY=dlYdmuY+dcdmuY./c;
    score_alpha=dcdalpha./c;

    Ifmle=[score_muX score_muY score_alpha]'*[score_muX score_muY score_alpha]/N;
    fmlevar=inv(Ifmle);


    k=10;

    Basis  = formCosBasis_var2(U,V,k);

    Pu=score_muX;
    Z=Basis./repmat(c,1,k*k);

    OptI1=-(Z'*Z)\(Z'*Pu);
    g1 = Basis * OptI1;

    Pv=score_muY;
    OptI2=-(Z'*Z)\(Z'*Pv);

    g2 = Basis * OptI2;

    score_u=score_muX+g1./c;
    score_v=score_muY+g2./c;

    Ismle=[score_u score_v]'*[score_u score_v]/N;
    smlevar=inv(Ismle);


    fprintf('%.3f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f\n',alpha,fmlevar(1,1),qmlevar_rob(1,1),smlevar(1,1),fmlevar(1,1)/qmlevar_rob(1,1),smlevar(1,1)/qmlevar_rob(1,1),fmlevar(2,2),qmlevar_rob(2,2),smlevar(2,2),fmlevar(2,2)/qmlevar_rob(2,2),smlevar(2,2)/qmlevar_rob(2,2));

end