%Estimates semiparametric bound for 2d case with exponential and Gaussian marginals and
%Plackett copula



seed=1;
muX=1;        %marginal parameter
muY=0;
N=1e6;      %sample size 

a= [0.015
0.0412222
0.0784556
0.128851
0.195478
0.282631
0.396273
0.544781
0.740148
1.35108
1.8356
2.52351
3.53818
5.11566
7.76089
12.7461
24.2588
66.115
];



for ia=1:length(a)
    
    
    alpha=a(ia);
    
    [U, V]=plackett_rnd(alpha,N,seed);
    
    X = expinv(U,muX);
    Y = norminv(V,muY,1);
    
    
    dlXdmuX=zeros(N,1);
    dlYdmuY=zeros(N,1);
    dcdmuX=zeros(N,1);
    dcdmuY=zeros(N,1);
    
    c=zeros(N,1);
    dcdalpha=zeros(N,1);
    
    dlXdmuX2=zeros(N,1);
    dlYdmuY2=zeros(N,1);
    
    
    for i=1:N
        
        u=U(i);
        v=V(i);
        x=X(i);
        y=Y(i);
        
        dlXdmuX(i)=(x-muX)/(muX^2);
        dlYdmuY(i)=y-muY;
        
        dFdmuX=-x*exp(-x/muX)/(muX^2);
        dFdmuY=-exp(-1/2*(y-muY)^2)/sqrt(2*pi);
        
        dcdu=((-1+alpha)*alpha*(3*(-1+u-alpha*u+v+alpha*v)*(1+(-1+alpha)*(u+v-2*u*v))+(1-2*v)*(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)))...
            /(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)^(5/2);
        
        dcdv=((-1+alpha)*alpha*(3*(-1+u+alpha*u+v-alpha*v)*(1+(-1+alpha)*(u+v-2*u*v))+(1-2*u)*(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)))...
            /(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2)^(5/2);
        
        
        dcdmuX(i)=dcdu*dFdmuX;
        dcdmuY(i)=dcdv*dFdmuY;
        
        c(i)=plackett_pdf(u,v,alpha);
        
        dcdalpha(i)=(-3*alpha*(2*(-1+alpha)*(u^2)+2*v*(1+(-1+alpha)*v)+u*(2-4*alpha*v))*(1+(-1+alpha)*(u+v-2*u*v))+2*alpha*(u+v-2*u*v)*(-4*(-1+alpha)*...
            alpha*u*v+(1+(-1+alpha)*(u+v))^2)+2*(1+(-1+alpha)*(u+v-2*u*v))*(-4*(-1+alpha)*alpha*u*v+(1+(-1+alpha)*(u+v))^2))/(2*(-4*(-1+alpha)*...
            alpha*u*v+(1+(-1+alpha)*(u+v))^2)^(5/2));
        
        dlXdmuX2(i)=(muX-2*x)/(muX^3);
        dlYdmuY2(i)=-1;
        
        
    end
    
    %qmle var
    
    
    Iqmle=[dlXdmuX dlYdmuY]'*[dlXdmuX dlYdmuY]/N;
    H=[mean(dlXdmuX2) 0; 0 mean(dlYdmuY2)];
    
    invH=inv(H);
    qmlevar_rob=invH*Iqmle*invH;
    
    %fmle var
    
    score_muX=dlXdmuX+dcdmuX./c;
    score_muY=dlYdmuY+dcdmuY./c;
    score_alpha=dcdalpha./c;
    
    Ifmle=[score_muX score_muY score_alpha]'*[score_muX score_muY score_alpha]/N;
    fmlevar=inv(Ifmle);
    
    
    k=10;
    
    Basis  = formCosBasis_var2(U,V,k);  
    Z=Basis./c;
    
    g=-Z*((Z'*Z)\(Z'*[score_muX score_muY]));
            
    score_uv=[score_muX score_muY]+g;
    
    
    Ismle=score_uv'*score_uv/N;
    smlevar=inv(Ismle);
    
    
    fprintf('%.3f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f %.5f\n',alpha,fmlevar(1,1),qmlevar_rob(1,1),smlevar(1,1),fmlevar(1,1)/qmlevar_rob(1,1),smlevar(1,1)/qmlevar_rob(1,1),fmlevar(2,2),qmlevar_rob(2,2),smlevar(2,2),fmlevar(2,2)/qmlevar_rob(2,2),smlevar(2,2)/qmlevar_rob(2,2));
    
end