function obj = IQMLE(Coefs, X,Y)
% Calculates IQMLE 
   
    mX = exp(Coefs(1));
    mY = exp(Coefs(2));
   
   
    % Compute scores
   
    dlXdmuX=(X-mX)/(mX^2);
    dlYdmuY=(Y-mY)/(mY^2);

    Escore_vec=[mean(dlXdmuX) mean(dlYdmuY)];

    %optimal weight calculation

    %Hessian

    dlXdmuX2=(mX-2*X)/(mX^3);
    dlYdmuY2=(mY-2*Y)/(mY^3);

    H=[mean(dlXdmuX2) 0; 0 mean(dlYdmuY2)];

    %covarinace of score
    C=cov([dlXdmuX dlYdmuY]);


    % weghted scores
    obj=Escore_vec*-H'/C*Escore_vec';   
   
end 