function logL = Loglikelihood_PMLEmisGaus(Coefs, X,Y)
% Calculates QMLE assuming independence

    n=length(X);
    
    mX = exp(Coefs(1));
    mY = exp(Coefs(2));
    d =  1/(1+exp(-Coefs(3)))*2-1; %d between -1 and 1
    
   
    %to avoid nan and inf
    if (mX==inf) 
        mX=1e7;
    elseif (mX==0)
        mX=1e-7;
    end

    if (mY==inf) 
        mY=1e7;
    elseif (mY==0)
        mX=1e-7;
    end

    
    U=expcdf(X,mX);
    V=expcdf(Y,mY);

    
    
    
    
    % Compute log-likelihood
     
   
    logL=n*log(1/mX)-sum(X)/mX+n*log(1/mY)-sum(Y)/mY+sum(log(copulapdf('Gaussian',[U,V],d)));
    logL=-logL;
end 