function nlogL  = Loglikelihood_SMLE_Bernstein_transf(Coeff,X,Y,k,nchoose)


n=length(X);

mX=exp(Coeff(1));
mY=exp(Coeff(2));

U=expcdf(X,mX);
V=expcdf(Y,mY);

Icoef=1./(1+exp(-Coeff(3:end)));

sumIcoef=Icoef(1);
for i=2:k*k-1
    Icoef(i)=(1-sumIcoef)*Icoef(i);
    sumIcoef=sumIcoef+Icoef(i);
end

I=reshape([Icoef; 1-sumIcoef],k,k);

prod1U=ones(k,1);
prod1V=ones(k,1);

logLc=0;
for l = 1:n

    for i=2:k
        prod1U(i)=prod1U(i-1)*(1-U(l));
        prod1V(i)=prod1V(i-1)*(1-V(l));
    end

    cl=0;
    prodU=1;

    for i = 1:k
        temp=0;
        prodV=1;
        for j = 1:k
            temp=temp+I(i,j)*nchoose(j)*prodV*prod1V(k-j+1);
            prodV=prodV*V(l);
        end
        cl=cl+temp*nchoose(i)*prodU*prod1U(k-i+1);
        prodU=prodU*U(l);
    end
    cl=cl*k*k;
    logLc=logLc+log(cl);
end

%exponential log likelihood

logL=n*log(1/mX)-sum(X)/mX+n*log(1/mY)-sum(Y)/mY;

rest=1/k;
penalty=sum((sum(I,1)-rest).^2+(sum(I,2)'-rest).^2);

const=1e4; %large constant to make sure penalty bites
nlogL=-logL-logLc+const*penalty;


end
