function nlogL  = Loglikelihood_SMLE_Tensor_series(Coeff,X,Y,k,formBasis,Integ_Basis)


    n=length(X);

    mX=1/(1+exp(-Coeff(1)))*max(X);
    mY=1/(1+exp(-Coeff(2)))*max(Y);
           
    U=expcdf(X,mX);
    V=expcdf(Y,mY);
     
    c_coef=Coeff(3:end);
   
    Basis=formBasis(U,V,k);

    logc=Basis*c_coef;

    msq=length(Integ_Basis); %squared mesh for integration
    intreg_c=sum(exp(Integ_Basis*c_coef))/msq; 
     

    logc=logc-log(intreg_c); %making sure that c integrates to 1 over all dimensions

    logLc=sum(logc);

        
    logL=n*log(1/mX)-sum(X)/mX+n*log(1/mY)-sum(Y)/mY;    
  
    nlogL=-logL-logLc;
    
end 
