function B = Spline3Basis (X,Y,J)

%J number of knots, such that t0=0, t_{J+1}=1, we use equidistant knots

%r order of spline; degree=(r-1)
r=3;

n=length(X);

t=(1:J)/(J+1);

BX=zeros(n,J+r);
BY=zeros(n,J+r);

Powx=ones(n,1);
Powy=ones(n,1);

BX(:,1)=Powx;
BY(:,1)=Powy;

for k=2:r

    Powx=Powx.*X;    
    Powy=Powy.*Y;

    BX(:,k)=Powx;
    BY(:,k)=Powy;
end

for j=1:J
    temp=X-t(j);
    ind=temp>0;
    BX(ind,r+j)=temp(ind).^(r-1);

    temp=Y-t(j);
    ind=temp>0;
    BY(ind,r+j)=temp(ind).^(r-1);     
end


B=zeros(n,(J+r)*(J+r));

for i = 1:(J+r)
    for j = 1:(J+r)
        B(:,(i-1)*(J+r)+j) = BX(:,i).*BY(:,j);
    end
end

end

