function sq_dif  = copula_ISE_Bernstein(I,k,alpha)


n=1000; % nxn - mesh over which ISE is computed


%constant to form polynomials faster
nchoose=zeros(k,1);

for j = 1:k
    nchoose(j)=nchoosek(k-1,j-1);
end


nchoose=zeros(k,1);

for j = 1:k
    nchoose(j)=nchoosek(k-1,j-1);
end



U=(1:(n-1))/n; %avoid 0 and 1 in the mesh 
V=(1:(n-1))/n; %avoid 0 and 1 in the mesh


prod1U=ones(k,1);
prod1V=ones(k,1);

sq_dif=0;
for lu = 1:n-1
    for lv = 1:n-1

        for i=2:k
            prod1U(i)=prod1U(i-1)*(1-U(lu));
            prod1V(i)=prod1V(i-1)*(1-V(lv));
        end

        cl=0;
        prodU=1;

        for i = 1:k
            temp=0;
            prodV=1;
            for j = 1:k
                temp=temp+I(i,j)*nchoose(j)*prodV*prod1V(k-j+1);
                prodV=prodV*V(lv);
            end
            cl=cl+temp*nchoose(i)*prodU*prod1U(k-i+1);
            prodU=prodU*U(lu);
        end

        cl=cl*k*k;
        sq_dif=sq_dif+(cl-plackett_pdf(U(lu), V(lv),alpha))^2;
    end
end

% Double Riemann Sum
sq_dif=sq_dif/n/n;

end
