(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    162361,       4586]
NotebookOptionsPosition[    158946,       4469]
NotebookOutlinePosition[    159368,       4485]
CellTagsIndexPosition[    159325,       4482]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"<<", "ToMatlab.m"}]], "Input"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "Unusual", " ", "Pareto", " ", "distribution", " ", "in", " ", "Frees", 
    " ", "and", " ", "Valdez"}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.6088653237053704`*^9, 3.6088653638356657`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Fx", "=", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["lamX", 
        RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.494475942265625*^9, 3.494475958125*^9}, 
   3.608864223576432*^9, {3.6088643154986897`*^9, 3.608864316244733*^9}, {
   3.6088643700338097`*^9, 3.608864470857576*^9}, {3.608865169564554*^9, 
   3.6088652263988047`*^9}, {3.608866256698747*^9, 3.6088662894486203`*^9}, {
   3.60886631986136*^9, 3.608866325300671*^9}, {3.6088663755095425`*^9, 
   3.6088663847470713`*^9}, {3.608876517417633*^9, 3.608876527377203*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.608877051637192*^9, 3.6088770788157463`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Fy", "=", 
    RowBox[{"1", "-", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["lamY", 
        RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.608873116629119*^9, 3.608873133004056*^9}, {
  3.608877068993184*^9, 3.60887707694864*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"fx", "=", 
   RowBox[{"Simplify", "[", 
    RowBox[{"D", "[", 
     RowBox[{"Fx", ",", "X"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.494390837203125*^9, 3.494390873921875*^9}, {
   3.49439103459375*^9, 3.494391040296875*^9}, {3.494391176859375*^9, 
   3.494391219375*^9}, {3.49447603653125*^9, 3.494476043515625*^9}, {
   3.49447660521875*^9, 3.494476606953125*^9}, {3.49447908678125*^9, 
   3.49447908725*^9}, 3.494479825640625*^9, {3.6088642981907005`*^9, 
   3.6088643102303886`*^9}, {3.6088652292269664`*^9, 3.608865288059332*^9}, {
   3.608866296135003*^9, 3.60886633174504*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{"thetX", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["lamX", 
      RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
  RowBox[{"lamX", "+", "X"}]]], "Output",
 CellChangeTimes->{3.608873101738268*^9, 3.6088765565868735`*^9, 
  3.6088817490238857`*^9, 3.6668528817721496`*^9, 3.6668555272966757`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{"thetX", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["lamX", 
      RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
  RowBox[{"lamX", "+", "X"}]]], "Input",
 CellChangeTimes->{3.6088663937175846`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"thetX", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["lamX", 
      RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
  RowBox[{"lamX", "+", "X"}]]], "Output",
 CellChangeTimes->{3.666852881793152*^9, 3.6668555273276787`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fy", "=", 
  FractionBox[
   RowBox[{"thetY", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["lamY", 
       RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
   RowBox[{"lamY", "+", "Y"}]]}]], "Input",
 CellChangeTimes->{{3.608866414667783*^9, 3.608866443274419*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{"thetY", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["lamY", 
      RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
  RowBox[{"lamY", "+", "Y"}]]], "Output",
 CellChangeTimes->{3.608881752799102*^9, 3.6668528818131533`*^9, 
  3.666855527359682*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", " ", "[", 
  RowBox[{"D", "[", 
   RowBox[{"Fx", ",", "thetX"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.608949952307741*^9, 3.6089499774741807`*^9}, {
  3.608950009548015*^9, 3.6089500912336874`*^9}, {3.6089503572589035`*^9, 
  3.6089503838924265`*^9}, {3.6089504635859847`*^9, 3.6089505058544025`*^9}, {
  3.6089505366261625`*^9, 3.608950540547387*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["lamX", 
      RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], " ", 
  RowBox[{"Log", "[", 
   FractionBox["lamX", 
    RowBox[{"lamX", "+", "X"}]], "]"}]}]], "Output",
 CellChangeTimes->{{3.6089500500913343`*^9, 3.608950091759718*^9}, {
   3.6089503612831335`*^9, 3.6089503845864663`*^9}, {3.6089504678092265`*^9, 
   3.6089505062384243`*^9}, 3.608950541024414*^9, 3.6668528818801603`*^9, 
   3.6668555274436903`*^9}]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{3.6089500679763575`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Censored", " ", "log", " ", "likelihood", " ", "no", " ", "dependence"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"l", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "d"}], ")"}], "*", 
     RowBox[{"Log", "[", "fx", "]"}]}], "+", 
    RowBox[{"d", "*", 
     RowBox[{"Log", "[", 
      RowBox[{"1", "-", "Fx"}], "]"}]}], "+", 
    RowBox[{"Log", "[", "fy", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.6088652656830516`*^9, 3.608865267019128*^9}, {
  3.6088653088835225`*^9, 3.60886531845107*^9}, {3.6088653722061443`*^9, 
  3.608865422951047*^9}, {3.6088658284892426`*^9, 3.6088658402069125`*^9}, {
  3.608866309206751*^9, 3.608866365704982*^9}, {3.608866398153838*^9, 
  3.608866401249015*^9}, {3.6088664519079123`*^9, 3.608866460525406*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", 
   RowBox[{"Log", "[", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["lamX", 
       RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "]"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", "d"}], ")"}], " ", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"thetX", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["lamX", 
         RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
     RowBox[{"lamX", "+", "X"}]], "]"}]}], "+", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"thetY", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["lamY", 
        RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
    RowBox[{"lamY", "+", "Y"}]], "]"}]}]], "Output",
 CellChangeTimes->{3.608934271671032*^9, 3.6668528819021626`*^9, 
  3.6668555274756937`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.6088673248388414`*^9, 3.6089342835217094`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"S", "=", 
  RowBox[{"FullSimplify", " ", "[", 
   RowBox[{"D", "[", 
    RowBox[{"l", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"lamX", ",", "thetX", ",", "lamY", ",", "thetY"}], "}"}], 
      "}"}]}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088654868707027`*^9, 3.6088655707655015`*^9}, {
  3.608866502671816*^9, 3.6088665558668585`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "lamX"}], "+", 
     RowBox[{"thetX", " ", "X"}]}], 
    RowBox[{"lamX", " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "+", "X"}], ")"}]}]], ",", 
   RowBox[{
    FractionBox[
     RowBox[{"1", "-", "d"}], "thetX"], "+", 
    RowBox[{"Log", "[", 
     FractionBox["lamX", 
      RowBox[{"lamX", "+", "X"}]], "]"}]}], ",", 
   FractionBox[
    RowBox[{
     RowBox[{"-", "lamY"}], "+", 
     RowBox[{"thetY", " ", "Y"}]}], 
    RowBox[{"lamY", " ", 
     RowBox[{"(", 
      RowBox[{"lamY", "+", "Y"}], ")"}]}]], ",", 
   RowBox[{
    FractionBox["1", "thetY"], "+", 
    RowBox[{"Log", "[", 
     FractionBox["lamY", 
      RowBox[{"lamY", "+", "Y"}]], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.608865546141093*^9, 3.6088655724896*^9}, 
   3.6088658455852203`*^9, {3.608866542356086*^9, 3.608866556318885*^9}, 
   3.6088673383016114`*^9, 3.6088676650573006`*^9, 3.608934349933508*^9, 
   3.6668528820021725`*^9, 3.666855527674713*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.6088668987414703`*^9, 3.60886706675808*^9}, {
   3.608867191907238*^9, 3.6088671930163016`*^9}, 3.6088672965082207`*^9, 
   3.6088674515290875`*^9, 3.6088676632491975`*^9, {3.608933931586568*^9, 
   3.608933931783579*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CDF", "[", 
  RowBox[{
   RowBox[{"CopulaDistribution", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<Frank\>\"", ",", "a"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"UniformDistribution", "[", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "]"}], ",", 
       RowBox[{"UniformDistribution", "[", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1"}], "}"}], "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"U", ",", "V"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6088716913235965`*^9, 3.6088717166760464`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"1", 
        RowBox[{
         RowBox[{"U", ">", "1"}], "&&", 
         RowBox[{"V", ">", "1"}]}]},
       {"U", 
        RowBox[{
         RowBox[{"0", "\[LessEqual]", "U", "\[LessEqual]", "1"}], "&&", 
         RowBox[{"V", ">", "1"}]}]},
       {"V", 
        RowBox[{
         RowBox[{"U", ">", "1"}], "&&", 
         RowBox[{"0", "\[LessEqual]", "V", "\[LessEqual]", "1"}]}]},
       {
        FractionBox[
         RowBox[{"Log", "[", 
          RowBox[{"1", "+", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["a", "U"]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["a", "V"]}], ")"}]}], 
            RowBox[{
             RowBox[{"-", "1"}], "+", "a"}]]}], "]"}], 
         RowBox[{"Log", "[", "a", "]"}]], 
        RowBox[{
         RowBox[{"0", "\[LessEqual]", "U", "\[LessEqual]", "1"}], "&&", 
         RowBox[{"0", "\[LessEqual]", "V", "\[LessEqual]", "1"}]}]},
       {"0", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}},
      Selectable->True]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.6088717324089465`*^9, 3.6668528821901913`*^9, 
  3.6668555279047365`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"a", "=", 
    RowBox[{"Exp", "[", 
     RowBox[{"-", "rho"}], "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.608871762824686*^9, 3.6088717820447855`*^9}, 
   3.608872496275637*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Cop", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"Log", "[", 
      RowBox[{"1", "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["a", "U"]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox["a", "V"]}], ")"}]}], 
        RowBox[{
         RowBox[{"-", "1"}], "+", "a"}]]}], "]"}], 
     RowBox[{"Log", "[", "a", "]"}]], ",", 
    RowBox[{"rho", ">", "0"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.608871746910776*^9, 3.608871749312913*^9}, {
  3.6088717898432317`*^9, 3.6088718333747215`*^9}, {3.608871909087052*^9, 
  3.60887191185321*^9}, {3.608872714450116*^9, 3.6088727392885365`*^9}, {
  3.6088765842804575`*^9, 3.6088766024504967`*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"Log", "[", 
    RowBox[{"1", "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "rho"}], " ", "U"}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "rho"}], " ", "V"}]]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", "rho"}]]}]]}], "]"}], "rho"]}]], "Output",
 CellChangeTimes->{
  3.6088725075312805`*^9, 3.608872740342597*^9, {3.60887659655716*^9, 
   3.6088766036995687`*^9}, 3.608881786347021*^9, 3.666852882607233*^9, 
   3.6668555283367796`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.608877139456215*^9, 3.6088771632375746`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"D", "[", 
      RowBox[{"Cop", ",", "U"}], "]"}], ",", "V"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088720556214333`*^9, 3.608872099713955*^9}, {
  3.608872768484206*^9, 3.608872769227249*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"rho", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", "U", "+", "V"}], ")"}]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho"}], 
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"U", "+", "V"}], ")"}]}]], "-", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "rho"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", "U"}]], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", "V"}]]}], ")"}]}]}], ")"}], "2"]]], "Output",
 CellChangeTimes->{
  3.6088720674881115`*^9, 3.6088721004679985`*^9, {3.6088727619018297`*^9, 
   3.608872770005294*^9}, 3.608876614168167*^9, 3.6088817935934353`*^9, 
   3.6668528828732595`*^9, 3.666855528611807*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"C2", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{"Cop", ",", "V"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.60887278812833*^9, 3.6088728088725166`*^9}, {
  3.6668528362976027`*^9, 3.6668528381057835`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", "rho"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", "U"}]]}], ")"}]}], 
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{"U", "+", "V"}], ")"}]}]]}], "+", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "rho"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", "U"}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", "V"}]]}], ")"}]}]}]]], "Output",
 CellChangeTimes->{3.608872812059699*^9, 3.608876618680425*^9, 
  3.6088817999397984`*^9, 3.666852882989271*^9, 3.666855528770823*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"U", "=", "Fx"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"V", "=", "Fy"}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.608872842190422*^9, 3.6088728575102987`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lF", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", "d"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Log", "[", "fx", "]"}], "+", 
        RowBox[{"Log", "[", "c", "]"}]}], ")"}]}], "+", 
     RowBox[{"d", "*", 
      RowBox[{"Log", "[", 
       RowBox[{"1", "-", "C2"}], "]"}]}], "+", 
     RowBox[{"Log", "[", "fy", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rho", ">", "0"}], ",", 
      RowBox[{"lamX", ">", "0"}], ",", 
      RowBox[{"thetX", ">", "0"}], ",", 
      RowBox[{"lamY", ">", "0"}], ",", 
      RowBox[{"thetY", ">", "0"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.608872860739483*^9, 3.608872919675854*^9}, {
  3.6088729570819936`*^9, 3.6088730326173143`*^9}, {3.6088731775076013`*^9, 
  3.608873180964799*^9}, {3.6088733676244755`*^9, 3.608873396112105*^9}, {
  3.608877183725747*^9, 3.608877216766637*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"d", " ", 
   RowBox[{"(", 
    RowBox[{"rho", "+", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}], 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}]], 
      "]"}]}], ")"}]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
        SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX"}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ExponentialE]", "rho"], "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
          "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
         ")"}], "2"]], "]"}], "+", 
     RowBox[{"Log", "[", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{"lamX", "+", "X"}]], ")"}], 
       RowBox[{"1", "+", "thetX"}]], "]"}]}], ")"}]}], "+", 
  RowBox[{"Log", "[", 
   RowBox[{
    SuperscriptBox["lamY", "thetY"], " ", "thetY", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["1", 
       RowBox[{"lamY", "+", "Y"}]], ")"}], 
     RowBox[{"1", "+", "thetY"}]]}], "]"}]}]], "Output",
 CellChangeTimes->{3.6088730430309095`*^9, 3.6088731625787477`*^9, 
  3.6088732123335934`*^9, 3.6088734356893682`*^9, 3.608876667943243*^9, 
  3.6088772633232994`*^9, 3.608881849120611*^9, 3.6668529131072826`*^9, 
  3.6668555590278482`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.6088719272500906`*^9, 3.6088719583618703`*^9}, {
  3.6088720010613127`*^9, 3.608872013142003*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sf", "=", 
  RowBox[{"D", "[", 
   RowBox[{"lF", ",", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"lamX", ",", "thetX", ",", "lamY", ",", "thetY", ",", "rho"}], 
      "}"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088654868707027`*^9, 3.6088655707655015`*^9}, {
   3.608866502671816*^9, 3.6088665558668585`*^9}, 3.6088730771078587`*^9, {
   3.6088732073203063`*^9, 3.608873245222474*^9}, 3.608873415204197*^9, {
   3.6088822667785*^9, 3.608882273120863*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"rho", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}]], 
     RowBox[{"d", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
       ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]], " ", "rho", 
          " ", "thetX", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "thetX"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["lamX", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"lamX", "+", "X"}], ")"}], "2"]]}], "+", 
            FractionBox["1", 
             RowBox[{"lamX", "+", "X"}]]}], ")"}]}], 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
          "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}]], 
        "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}], ")"}], 
          " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             " ", "rho", " ", "thetX", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], 
              RowBox[{
               RowBox[{"-", "1"}], "+", "thetX"}]], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["lamX", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"lamX", "+", "X"}], ")"}], "2"]]}], "+", 
               FractionBox["1", 
                RowBox[{"lamX", "+", "X"}]]}], ")"}]}], "-", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", "rho", " ", "thetX", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], 
              RowBox[{
               RowBox[{"-", "1"}], "+", "thetX"}]], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["lamX", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"lamX", "+", "X"}], ")"}], "2"]]}], "+", 
               FractionBox["1", 
                RowBox[{"lamX", "+", "X"}]]}], ")"}]}]}], ")"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "2"]]}], ")"}]}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"1", "+", "thetX"}], 
         RowBox[{"lamX", "+", "X"}]]}], "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho", 
          " ", "thetX"}]], 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "rho"}], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "rho"], "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "2"], " ", 
         SuperscriptBox["lamX", 
          RowBox[{"-", "thetX"}]], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", 
              RowBox[{
               RowBox[{"-", "1"}], "+", "thetX"}]], " ", "rho", " ", 
             SuperscriptBox["thetX", "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "2"]], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", "thetX"], " ", 
             SuperscriptBox["rho", "2"], " ", 
             SuperscriptBox["thetX", "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], 
              RowBox[{
               RowBox[{"-", "1"}], "+", "thetX"}]], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["lamX", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"lamX", "+", "X"}], ")"}], "2"]]}], "+", 
               FractionBox["1", 
                RowBox[{"lamX", "+", "X"}]]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "2"]], "-", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"rho", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
                    ")"}]}]]}], " ", "rho", " ", "thetX", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", "thetX"}]], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox["lamX", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"lamX", "+", "X"}], ")"}], "2"]]}], "+", 
                  FractionBox["1", 
                   RowBox[{"lamX", "+", "X"}]]}], ")"}]}], "+", 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"rho", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
                " ", "rho", " ", "thetX", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", "thetX"}]], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox["lamX", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"lamX", "+", "X"}], ")"}], "2"]]}], "+", 
                  FractionBox["1", 
                   RowBox[{"lamX", "+", "X"}]]}], ")"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "3"]]}], ")"}]}]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"rho", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}]], 
     RowBox[{"d", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "-", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"rho", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
       ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]], " ", "rho", 
          " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], " ", 
          RowBox[{"Log", "[", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], "]"}]}], 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
          "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}]], 
        "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}], ")"}], 
          " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             " ", "rho", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], " ", 
             RowBox[{"Log", "[", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], "]"}]}], "-", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", "rho", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], " ", 
             RowBox[{"Log", "[", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], "]"}]}]}], ")"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "2"]]}], ")"}]}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox["1", 
         RowBox[{"lamX", "+", "X"}]], "]"}], "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho", 
          " ", "thetX"}]], 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           RowBox[{"-", "rho"}], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "rho"], "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "2"], " ", 
         SuperscriptBox["lamX", 
          RowBox[{"-", "thetX"}]], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", "thetX"], " ", "rho"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "2"]], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
             RowBox[{"Log", "[", "lamX", "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "2"]], "+", 
           FractionBox[
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", "thetX"], " ", 
             SuperscriptBox["rho", "2"], " ", "thetX", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], " ", 
             RowBox[{"Log", "[", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], "]"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "2"]], "-", 
           FractionBox[
            RowBox[{"2", " ", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
             SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["\[ExponentialE]", 
                  RowBox[{"rho", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
                    ")"}]}]]}], " ", "rho", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], " ", 
                RowBox[{"Log", "[", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], "]"}]}], "+", 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"rho", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
                " ", "rho", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], " ", 
                RowBox[{"Log", "[", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ExponentialE]", "rho"], "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "3"]]}], ")"}]}]}]}], ")"}]}]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["lamY", 
       RowBox[{"-", "thetY"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{"lamY", "+", "Y"}]], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "-", "thetY"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["lamY", 
          RowBox[{
           RowBox[{"-", "1"}], "+", "thetY"}]], " ", 
         SuperscriptBox["thetY", "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{"1", "+", "thetY"}]]}], "-", 
        RowBox[{
         SuperscriptBox["lamY", "thetY"], " ", "thetY", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", "thetY"}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{"2", "+", "thetY"}]]}]}], ")"}]}], "thetY"], "-", 
    FractionBox[
     RowBox[{"d", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ",
          "rho", " ", "thetY", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{
           RowBox[{"-", "1"}], "+", "thetY"}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["lamY", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"lamY", "+", "Y"}], ")"}], "2"]]}], "+", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]]}], ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ",
          "rho", " ", "thetY", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{
           RowBox[{"-", "1"}], "+", "thetY"}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["lamY", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"lamY", "+", "Y"}], ")"}], "2"]]}], "+", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]]}], ")"}]}]}], ")"}]}], 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}]], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho", " ", 
       "thetX"}]], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "rho"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", "rho"], "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
        ")"}], "2"], " ", 
      SuperscriptBox["lamX", 
       RowBox[{"-", "thetX"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
          SuperscriptBox["lamX", "thetX"], " ", 
          SuperscriptBox["rho", "2"], " ", "thetX", " ", "thetY", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "thetY"}]], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["lamY", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"lamY", "+", "Y"}], ")"}], "2"]]}], "+", 
            FractionBox["1", 
             RowBox[{"lamY", "+", "Y"}]]}], ")"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "rho"], "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "2"]], "-", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
          SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"rho", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                 ")"}]}]]}], " ", "rho", " ", "thetY", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], 
              RowBox[{
               RowBox[{"-", "1"}], "+", "thetY"}]], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["lamY", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"lamY", "+", "Y"}], ")"}], "2"]]}], "+", 
               FractionBox["1", 
                RowBox[{"lamY", "+", "Y"}]]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", "rho", " ", "thetY", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], 
              RowBox[{
               RowBox[{"-", "1"}], "+", "thetY"}]], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["lamY", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"lamY", "+", "Y"}], ")"}], "2"]]}], "+", 
               FractionBox["1", 
                RowBox[{"lamY", "+", "Y"}]]}], ")"}]}]}], ")"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "rho"], "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "3"]]}], ")"}]}]}]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox["lamY", 
       RowBox[{"-", "thetY"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{"lamY", "+", "Y"}]], ")"}], 
       RowBox[{
        RowBox[{"-", "1"}], "-", "thetY"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["lamY", "thetY"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{"1", "+", "thetY"}]]}], "+", 
        RowBox[{
         SuperscriptBox["lamY", "thetY"], " ", "thetY", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{"1", "+", "thetY"}]], " ", 
         RowBox[{"Log", "[", "lamY", "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["lamY", "thetY"], " ", "thetY", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["1", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], 
          RowBox[{"1", "+", "thetY"}]], " ", 
         RowBox[{"Log", "[", 
          FractionBox["1", 
           RowBox[{"lamY", "+", "Y"}]], "]"}]}]}], ")"}]}], "thetY"], "-", 
    FractionBox[
     RowBox[{"d", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ",
          "rho", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"], " ", 
         RowBox[{"Log", "[", 
          FractionBox["lamY", 
           RowBox[{"lamY", "+", "Y"}]], "]"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ",
          "rho", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"], " ", 
         RowBox[{"Log", "[", 
          FractionBox["lamY", 
           RowBox[{"lamY", "+", "Y"}]], "]"}]}]}], ")"}]}], 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}]], "-", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho", " ", 
       "thetX"}]], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"-", "rho"}], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", "rho"], "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
        ")"}], "2"], " ", 
      SuperscriptBox["lamX", 
       RowBox[{"-", "thetX"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
          SuperscriptBox["lamX", "thetX"], " ", 
          SuperscriptBox["rho", "2"], " ", "thetX", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"], " ", 
          RowBox[{"Log", "[", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], "]"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "rho"], "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "2"]], "-", 
        FractionBox[
         RowBox[{"2", " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
          SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"rho", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                 ")"}]}]]}], " ", "rho", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"], " ", 
             RowBox[{"Log", "[", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], "]"}]}], "+", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             " ", "rho", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"], " ", 
             RowBox[{"Log", "[", 
              FractionBox["lamY", 
               RowBox[{"lamY", "+", "Y"}]], "]"}]}]}], ")"}]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ExponentialE]", "rho"], "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
            "-", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
            "+", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}],
            ")"}], "3"]]}], ")"}]}]}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho", " ", 
        "thetX"}]], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{"-", "rho"}], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ExponentialE]", "rho"], "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
          "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
          "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
         ")"}], "2"], " ", 
       SuperscriptBox["lamX", 
        RowBox[{"-", "thetX"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamY", 
                  RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
           " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
           SuperscriptBox["lamX", "thetX"], " ", "thetX"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", "rho"], "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             "+", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                ")"}]}]]}], ")"}], "2"]], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", "+", 
             RowBox[{"rho", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}]],
            " ", 
           SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", "rho"], "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             "+", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                ")"}]}]]}], ")"}], "2"]], "+", 
         FractionBox[
          RowBox[{
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamY", 
                  RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
           " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
           SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", "rho"], "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             "+", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                ")"}]}]]}], ")"}], "2"]], "-", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamY", 
                  RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
           " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", 
           SuperscriptBox["lamX", "thetX"], " ", "rho", " ", "thetX", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", "rho"], "-", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"rho", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
              " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}], 
             "-", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"rho", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
              " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], 
             "+", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{"rho", " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
              " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamX", 
                   RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                SuperscriptBox[
                 RowBox[{"(", 
                  FractionBox["lamY", 
                   RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
            ")"}]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ExponentialE]", "rho"], "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             "+", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                ")"}]}]]}], ")"}], "3"]]}], ")"}]}]}]}], "+", 
    RowBox[{"d", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}]], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
           "+", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamY", 
                  RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
           "-", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"rho", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamY", 
                  RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
          ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
             "+", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
             "-", 
             SuperscriptBox["\[ExponentialE]", 
              RowBox[{"rho", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                ")"}]}]]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}], ")"}], 
             " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"rho", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
                " ", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}], 
               "+", 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"rho", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
                " ", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], 
               "-", 
               RowBox[{
                SuperscriptBox["\[ExponentialE]", 
                 RowBox[{"rho", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
                " ", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}],
               ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], 
               "+", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], 
               "-", 
               SuperscriptBox["\[ExponentialE]", 
                RowBox[{"rho", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamX", 
                    RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    FractionBox["lamY", 
                    RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
                  ")"}]}]]}], ")"}], "2"]]}], ")"}]}]}]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.608881688687435*^9, {3.608882258613033*^9, 3.6088822746739516`*^9}, 
   3.6668529131882906`*^9, 3.666855559333879*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"sxl", "=", 
    RowBox[{"FullSimplify", "[", 
     RowBox[{
      RowBox[{"Sf", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"rho", ">", "0"}], ",", 
        RowBox[{"lamX", ">", "0"}], ",", 
        RowBox[{"thetX", ">", "0"}], ",", 
        RowBox[{"lamY", ">", "0"}], ",", 
        RowBox[{"thetY", ">", "0"}]}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.608876085294917*^9, 3.60887609845467*^9}, {
  3.6088761377649183`*^9, 3.608876198726405*^9}, {3.6088764448804846`*^9, 
  3.608876452229905*^9}, {3.6088823357984476`*^9, 3.608882347817135*^9}, {
  3.608883105659481*^9, 3.6088831371132803`*^9}, {3.6088832306556306`*^9, 
  3.6088832326587453`*^9}, {3.608883356125807*^9, 3.6088833586179495`*^9}, {
  3.6088909962747984`*^9, 3.6088910227433124`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"thetX", " ", "X"}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"d", " ", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d", "-", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", "+", 
       RowBox[{"2", " ", "rho", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", "rho"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"d", " ", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "rho"], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
     ")"}], " ", "lamX", " ", 
    RowBox[{"(", 
     RowBox[{"lamX", "+", "X"}], ")"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.6088916380445056`*^9, 3.6668529198339553`*^9, 
  3.666855566004546*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     RowBox[{"Exp", "[", "rho", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     RowBox[{"Exp", "[", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], "]"}], 
     " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], "]"}], 
     " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "lamX"}], "-", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}], "]"}], 
     " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"d", " ", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Exp", "[", "rho", "]"}], "-", 
      RowBox[{"Exp", "[", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}], "]"}], 
      "-", 
      RowBox[{"Exp", "[", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], "]"}], 
      "+", 
      RowBox[{"Exp", "[", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], "]"}]}],
      ")"}], " ", "lamX", " ", 
    RowBox[{"(", 
     RowBox[{"lamX", "+", "X"}], ")"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.6088910661497955`*^9, 3.6088911922300067`*^9}, {
  3.608891226099944*^9, 3.608891254158549*^9}, {3.608891391186386*^9, 
  3.6088914587342496`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", "rho"], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "lamX"}], "-", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamX", "-", 
       RowBox[{"d", " ", "lamX"}], "+", 
       RowBox[{"thetX", " ", "X", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", "d", "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}], ")"}]}]}], 
      ")"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "rho"], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
     ")"}], " ", "lamX", " ", 
    RowBox[{"(", 
     RowBox[{"lamX", "+", "X"}], ")"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.6668529199139633`*^9, 3.6668555660985556`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"ToMatlab", "[", 
   RowBox[{"sxl", ",", "160"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088832370339956`*^9, 3.6088832680477695`*^9}, {
  3.6088833681774964`*^9, 3.6088833688745365`*^9}, {3.6088916094298687`*^9, 
  3.6088916241447105`*^9}, {3.6088916582496614`*^9, 3.6088916586456842`*^9}, {
  3.608891892652068*^9, 3.608891901678585*^9}, {3.608891944672044*^9, 
  3.608891946305137*^9}}],

Cell[BoxData["\<\"((-1)+exp(1).^(rho.*(lamX.*(lamX+X).^(-1)).^thetX)).^(-1).*(\
exp(1).^rho+(-1).*exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX))+(-1).*exp(\
1).^(rho.*(1+(lamY.*( ...\\n  \
lamY+Y).^(-1)).^thetY))+exp(1).^(rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(\
lamY+Y).^(-1)).^thetY))).^(-1).*lamX.^(-1).*(lamX+X).^(-1).*(2.*((-1)+d).*exp(\
1).^( ...\\n  \
rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX)).*(lamX+(-1).*thetX.*X)+exp(1).^(rho.*(\
1+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)).*(lamX+(-1).*\
d.* ...\\n  \
lamX+thetX.*X.*((-1)+d+(-1).*rho.*(lamX.*(lamX+X).^(-1)).^thetX))+(-1).*((-1)+\
d).*exp(1).^(rho+2.*rho.*(lamX.*(lamX+X).^(-1)).^thetX).*(lamX+thetX.*X.*((-1)\
+ ...\\n  \
rho.*(lamX.*(lamX+X).^(-1)).^thetX))+((-1)+d).*exp(1).^(rho.*(2.*(lamX.*(lamX+\
X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)).*(lamX+thetX.*X.*((-1)+rho.*(\
 ...\\n  lamX.*(lamX+X).^(-1)).^thetX))+((-1)+d).*exp(1).^(rho.*(1+(lamY.*(\
lamY+Y).^(-1)).^thetY)).*(lamX+(-1).*thetX.*X.*(1+rho.*(lamX.*(lamX+X).^(-1)).\
^thetX))+((-1)+ ...\\n  \
d).*exp(1).^rho.*((-1).*lamX+thetX.*X.*(1+rho.*(lamX.*(lamX+X).^(-1)).^thetX))\
+exp(1).^(rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)).\
*( ...\\n  \
lamX+(-1).*d.*lamX+thetX.*X.*((-1)+d+rho.*(lamX.*(lamX+X).^(-1)).^thetX)));\\\
n\"\>"], "Output",
 CellChangeTimes->{{3.608891628022932*^9, 3.6088916596877437`*^9}, {
   3.608891894867195*^9, 3.6088919027786474`*^9}, 3.608891947103183*^9, 
   3.666852919953967*^9, 3.666855566137559*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sXt", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Sf", "[", 
     RowBox[{"[", "2", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rho", ">", "0"}], ",", 
      RowBox[{"lamX", ">", "0"}], ",", 
      RowBox[{"thetX", ">", "0"}], ",", 
      RowBox[{"lamY", ">", "0"}], ",", 
      RowBox[{"thetY", ">", "0"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088835387432523`*^9, 3.6088835451596193`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"1", "-", "d"}], "thetX"], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", "d", "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "d"}], ")"}]}], " ", 
          SuperscriptBox["\[ExponentialE]", "rho"]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", "+", 
            RowBox[{"2", " ", "rho", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]}]]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
         "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}]}],
         ")"}], " ", "rho", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["lamX", 
          RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", "rho"], "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
        ")"}]}]]}], ")"}], " ", 
   RowBox[{"Log", "[", 
    FractionBox["lamX", 
     RowBox[{"lamX", "+", "X"}]], "]"}]}]}]], "Output",
 CellChangeTimes->{3.608883557096302*^9, 3.666852954503422*^9, 
  3.6668556007650213`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToMatlab", "[", 
  RowBox[{"sXt", ",", "160"}], "]"}]], "Input",
 CellChangeTimes->{{3.608884372946966*^9, 3.608884373213981*^9}}],

Cell[BoxData["\<\"(1+(-1).*d).*thetX.^(-1)+(1+(-1).*d+(-1).*((-1)+exp(1).^(\
rho.*(lamX.*(lamX+X).^(-1)).^thetX)).^(-1).*(exp(1).^rho+(-1).*exp(1).^(rho.*(\
1+(lamX.*(lamX+X).^(-1)) ...\\n  \
.^thetX))+(-1).*exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(rho.\
*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))).^(-1).*((-1).\
*(( ...\\n  \
-1)+d).*exp(1).^rho+((-1)+d).*exp(1).^(rho+2.*rho.*(lamX.*(lamX+X).^(-1)).^\
thetX)+((-1)+d).*exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)).^thetY))+(-1).*exp(1)\
.^( ...\\n  \
rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(\
rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))+(-1).*((\
-1)+ ...\\n  \
d).*exp(1).^(rho.*(2.*(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^\
thetY))).*rho.*(lamX.*(lamX+X).^(-1)).^thetX).*log(lamX.*(lamX+X).^(-1));\\n\"\
\>"], "Output",
 CellChangeTimes->{3.608884375007084*^9, 3.6668529546034317`*^9, 
  3.6668556009120364`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"sYl", "=", 
   RowBox[{"FullSimplify", "[", 
    RowBox[{
     RowBox[{"Sf", "[", 
      RowBox[{"[", "3", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"rho", ">", "0"}], ",", 
       RowBox[{"lamX", ">", "0"}], ",", 
       RowBox[{"thetX", ">", "0"}], ",", 
       RowBox[{"lamY", ">", "0"}], ",", 
       RowBox[{"thetY", ">", "0"}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.6088921306956835`*^9, 3.608892139391181*^9}, {
  3.6088922414500184`*^9, 3.608892242535081*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamY", "+", 
       RowBox[{"thetY", " ", "Y", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}]}], ")"}]}]}], 
      ")"}]}], "-", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamY", "+", 
       RowBox[{"thetY", " ", "Y", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", "rho"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "lamY"}], "+", 
       RowBox[{"thetY", " ", "Y", " ", 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}]}], ")"}]}]}], 
      ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"rho", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamX", 
            RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], " ", 
     RowBox[{"(", 
      RowBox[{"lamY", "+", 
       RowBox[{"thetY", " ", "Y", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", "rho", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}]}], ")"}]}]}], 
      ")"}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", "rho"], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
     ")"}], " ", "lamY", " ", 
    RowBox[{"(", 
     RowBox[{"lamY", "+", "Y"}], ")"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.608892181174571*^9, 3.608892243720148*^9, 
  3.6668529563716087`*^9, 3.666855602699215*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToMatlab", "[", 
  RowBox[{"sYl", ",", "160"}], "]"}]], "Input",
 CellChangeTimes->{{3.608892615466411*^9, 3.608892617823546*^9}}],

Cell[BoxData["\<\"(exp(1).^rho+(-1).*exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^\
thetX))+(-1).*exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(rho.*(\
(lamX.*(lamX+X).^(-1)) ...\\n  \
.^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))).^(-1).*lamY.^(-1).*(lamY+Y).^(-1).*(\
exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)).^thetY)).*(lamY+thetY.*Y.*((-1)+rho.*(\
 ...\\n  lamY.*(lamY+Y).^(-1)).^thetY))+(-1).*exp(1).^(rho.*((lamX.*(lamX+X).^\
(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)).*(lamY+thetY.*Y.*((-1)+rho.*(\
lamY.*(lamY+Y).^( ...\\n  \
-1)).^thetY))+exp(1).^rho.*((-1).*lamY+thetY.*Y.*(1+(-1).*((-1)+d).*rho.*(\
lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX)\
).*( ...\\n  \
lamY+thetY.*Y.*((-1)+((-1)+d).*rho.*(lamY.*(lamY+Y).^(-1)).^thetY)));\\n\"\>"]\
, "Output",
 CellChangeTimes->{3.608892619026615*^9, 3.6668529564496164`*^9, 
  3.6668556028422294`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sYt", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"Sf", "[", 
     RowBox[{"[", "4", "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"rho", ">", "0"}], ",", 
      RowBox[{"lamX", ">", "0"}], ",", 
      RowBox[{"thetX", ">", "0"}], ",", 
      RowBox[{"lamY", ">", "0"}], ",", 
      RowBox[{"thetY", ">", "0"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.608892733271149*^9, 3.608892742221661*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "thetY"], "+", 
  RowBox[{"Log", "[", "lamY", "]"}], "+", 
  RowBox[{"Log", "[", 
   FractionBox["1", 
    RowBox[{"lamY", "+", "Y"}]], "]"}], "-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
       SuperscriptBox["\[ExponentialE]", "rho"]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"rho", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]]}], "-", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamX", 
             RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
          SuperscriptBox[
           RowBox[{"(", 
            FractionBox["lamY", 
             RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
     ")"}], " ", "rho", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["lamY", 
       RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"], " ", 
    RowBox[{"Log", "[", 
     FractionBox["lamY", 
      RowBox[{"lamY", "+", "Y"}]], "]"}]}], 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "rho"], "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamY", 
           RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamY", 
           RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], 
       ")"}]}]]}]]}]], "Output",
 CellChangeTimes->{3.608892793592599*^9, 3.666852963578329*^9, 
  3.666855609996945*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToMatlab", "[", 
  RowBox[{"sYt", ",", "160"}], "]"}]], "Input",
 CellChangeTimes->{{3.6088928752492695`*^9, 3.6088928760253143`*^9}}],

Cell[BoxData["\<\"thetY.^(-1)+log(lamY)+log((lamY+Y).^(-1))+(-1).*(exp(1).^\
rho+(-1).*exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX))+(-1).*exp(1).^(rho.\
*(1+(lamY.*(lamY+Y).^(-1) ...\\n  \
).^thetY))+exp(1).^(rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1))\
.^thetY))).^(-1).*(((-1)+d).*exp(1).^rho+(-1).*((-1)+d).*exp(1).^(rho.*(1+(\
lamX.*( ...\\n  \
lamX+X).^(-1)).^thetX))+(-1).*exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)).^thetY))\
+exp(1).^(rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)))\
.* ...\\n  \
rho.*(lamY.*(lamY+Y).^(-1)).^thetY.*log(lamY.*(lamY+Y).^(-1));\\n\"\>"], \
"Output",
 CellChangeTimes->{3.6088928774883976`*^9, 3.6668529636553373`*^9, 
  3.6668556101029553`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sk", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Sf", "[", 
    RowBox[{"[", "5", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6088929653404226`*^9, 3.6088929689736304`*^9}, {
   3.608933236434808*^9, 3.6089332520096984`*^9}, 3.6089357997154307`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"d", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
         " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["lamY", 
            RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox["lamX", 
               RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamX", 
              RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["lamY", 
              RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
       ")"}]}], 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{"rho", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}]]}]], "-", 
    RowBox[{
     RowBox[{"1", "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["\[ExponentialE]", "rho"]}], ")"}], " ", "rho"}], 
       ")"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "d"}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "-", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "-", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "-", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox[
                RowBox[{"(", 
                 FractionBox["lamX", 
                  RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"rho", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamX", 
                RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
             SuperscriptBox[
              RowBox[{"(", 
               FractionBox["lamY", 
                RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", "rho"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"2", " ", "rho"}]], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"rho", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamX", 
                 RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox["lamY", 
                 RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]}], 
          ")"}]}]}], ")"}]}]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "rho"], "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"]}], ")"}]}]], "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamY", 
           RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]], "+", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"rho", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamX", 
           RowBox[{"lamX", "+", "X"}]], ")"}], "thetX"], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["lamY", 
           RowBox[{"lamY", "+", "Y"}]], ")"}], "thetY"]}], ")"}]}]]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.666852964545426*^9, 3.6668556110650516`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToMatlab", "[", 
  RowBox[{"sk", ",", "160"}], "]"}]], "Input",
 CellChangeTimes->{{3.608933265343461*^9, 3.6089332658614907`*^9}}],

Cell[BoxData["\<\"(exp(1).^rho+(-1).*exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^\
thetX))+(-1).*exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(rho.*(\
(lamX.*(lamX+X).^(-1)) ...\\n  \
.^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))).^(-1).*(d.*((-1)+exp(1).^(rho.*(lamX.\
*(lamX+X).^(-1)).^thetX)).^(-1).*((-1).*exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)\
) ...\\n  \
.^thetY)).*(lamY.*(lamY+Y).^(-1)).^thetY+(-1).*exp(1).^(rho.*(2.*(lamX.*(lamX+\
X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)).*((-1)+(lamY.*(lamY+Y).^(-1))\
 ...\\n  .^thetY)+exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+\
Y).^(-1)).^thetY)).*((-1).*(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)\
).^thetY)+ ...\\n  \
exp(1).^(rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY)).*\
((-1)+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))+(-1).*((-\
1)+d) ...\\n  \
.*((-1)+exp(1).^rho).^(-1).*rho.^(-1).*(exp(1).^(rho.*(1+(lamY.*(lamY+Y).^(-1)\
).^thetY)).*(1+rho.*((-1)+(lamX.*(lamX+X).^(-1)).^thetX+(-1).*(lamY.*(lamY+Y).\
^( ...\\n  \
-1)).^thetY))+exp(1).^(rho.*(2+(lamX.*(lamX+X).^(-1)).^thetX)).*((-1)+rho.*((\
lamX.*(lamX+X).^(-1)).^thetX+(-1).*(lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(\
rho.*( ...\\n  \
1+(lamX.*(lamX+X).^(-1)).^thetX)).*(1+rho.*((-1)+(-1).*(lamX.*(lamX+X).^(-1)).\
^thetX+(lamY.*(lamY+Y).^(-1)).^thetY))+exp(1).^(rho.*(2+(lamY.*(lamY+Y).^(-1))\
 ...\\n  .^thetY)).*((-1)+rho.*((-1).*(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(\
lamY+Y).^(-1)).^thetY))+exp(1).^(rho.*(1+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*\
(lamY+Y).^(-1)) ...\\n  \
.^thetY)).*(1+(-1).*rho.*((-2)+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^\
(-1)).^thetY))+exp(1).^(rho.*((lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(\
-1)) ...\\n  \
.^thetY)).*((-1)+rho.*((-1)+(lamX.*(lamX+X).^(-1)).^thetX+(lamY.*(lamY+Y).^(-\
1)).^thetY))+(-1).*exp(1).^rho.*(1+rho.*((-1)+(lamX.*(lamX+X).^(-1)).^thetX+(\
lamY.* ...\\n  \
(lamY+Y).^(-1)).^thetY))+exp(1).^(2.*rho).*(1+rho.*((lamX.*(lamX+X).^(-1)).^\
thetX+(lamY.*(lamY+Y).^(-1)).^thetY))));\\n\"\>"], "Output",
 CellChangeTimes->{3.6089332691836805`*^9, 3.666852964594431*^9, 
  3.6668556112030654`*^9}]
}, Open  ]]
},
WindowSize->{1664, 915},
WindowMargins->{{0, Automatic}, {Automatic, -37}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
FrontEndVersion->"10.1 for Microsoft Windows (64-bit) (March 23, 2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 54, 1, 31, "Input"],
Cell[602, 23, 274, 6, 52, "Input"],
Cell[879, 31, 690, 15, 69, "Input"],
Cell[1572, 48, 94, 1, 31, "Input"],
Cell[1669, 51, 389, 11, 89, "Input"],
Cell[CellGroupData[{
Cell[2083, 66, 656, 13, 52, "Input"],
Cell[2742, 81, 353, 9, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3132, 95, 255, 8, 55, "Input"],
Cell[3390, 105, 278, 8, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3705, 118, 307, 9, 55, "Input"],
Cell[4015, 129, 303, 9, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4355, 143, 400, 7, 31, "Input"],
Cell[4758, 152, 512, 13, 47, "Output"]
}, Open  ]],
Cell[5285, 168, 89, 1, 52, "Input"],
Cell[CellGroupData[{
Cell[5399, 173, 835, 20, 52, "Input"],
Cell[6237, 195, 858, 28, 55, "Output"]
}, Open  ]],
Cell[7110, 226, 94, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[7229, 231, 390, 10, 31, "Input"],
Cell[7622, 243, 1115, 34, 48, "Output"]
}, Open  ]],
Cell[8752, 280, 325, 5, 72, "Input"],
Cell[CellGroupData[{
Cell[9102, 289, 607, 17, 31, "Input"],
Cell[9712, 308, 2634, 76, 118, "Output"]
}, Open  ]],
Cell[12361, 387, 253, 7, 52, "Input"],
Cell[CellGroupData[{
Cell[12639, 398, 876, 24, 65, "Input"],
Cell[13518, 424, 860, 26, 64, "Output"]
}, Open  ]],
Cell[14393, 453, 94, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[14512, 458, 319, 8, 31, "Input"],
Cell[14834, 468, 1055, 30, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15926, 503, 265, 6, 31, "Input"],
Cell[16194, 511, 845, 25, 56, "Output"]
}, Open  ]],
Cell[17054, 539, 230, 5, 72, "Input"],
Cell[CellGroupData[{
Cell[17309, 548, 979, 26, 31, "Input"],
Cell[18291, 576, 4377, 125, 153, "Output"]
}, Open  ]],
Cell[22683, 704, 147, 2, 31, "Input"],
Cell[CellGroupData[{
Cell[22855, 710, 502, 11, 31, "Input"],
Cell[23360, 723, 86575, 2314, 2027, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109972, 3042, 922, 21, 72, "Input"],
Cell[110897, 3065, 6725, 209, 169, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117659, 3279, 4283, 138, 123, "Input"],
Cell[121945, 3419, 4214, 131, 89, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[126196, 3555, 449, 8, 52, "Input"],
Cell[126648, 3565, 1514, 24, 192, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128199, 3594, 473, 13, 31, "Input"],
Cell[128675, 3609, 4695, 133, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133407, 3747, 154, 3, 31, "Input"],
Cell[133564, 3752, 977, 16, 132, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[134578, 3773, 572, 16, 52, "Input"],
Cell[135153, 3791, 4147, 128, 89, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[139337, 3924, 154, 3, 31, "Input"],
Cell[139494, 3929, 891, 14, 132, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[140422, 3948, 469, 13, 31, "Input"],
Cell[140894, 3963, 2852, 88, 77, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143783, 4056, 158, 3, 31, "Input"],
Cell[143944, 4061, 720, 12, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[144701, 4078, 286, 6, 31, "Input"],
Cell[144990, 4086, 11592, 336, 291, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[156619, 4427, 155, 3, 31, "Input"],
Cell[156777, 4432, 2153, 34, 272, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
